compDistWrapper <-
function(PEAKS,CompIDxs,Factors,HistNames,method='MMD',sigma){
  nPeaks <- length(PEAKS)
  nComps <-   ncol(CompIDxs)

  time <- 0
  Dists <- matrix(0,nPeaks,nComps)
  mDists <- matrix(0,nPeaks,nComps)
  for (i in 1:nPeaks){
    P <- PEAKS[[i]]
    for (j in 1:nComps){
      id1 <- CompIDxs[1,j]
      id2 <- CompIDxs[2,j]

      if (!identical(rownames(P)[id1],HistNames[[1,j]])||!identical(rownames(P)[id2],HistNames[[2,j]])){

        stop('samples wrong')}

      dist <- compDist(P[id1,]/Factors[1,j],P[id2,]/Factors[2,j],method,sigma=sigma)
      Dists[i,j] <- dist$val
      if (method=='MMD'){
        mDists[i,j] <- dist$mdist
      }
      time <- time+dist$time[[1]]
    }

    if((i%%100)==0){
      est <- (nPeaks-i)*time/i/60
      est <- round(1.5*est)
      message("\r\t", i, " of ", nPeaks," computed (estimated remaining time: ",est,"min )");
    }
  }
  message("\r\t DONE");
 # if (!is.null(out.dir)){
 #     fn <- paste(out.dir,'tmp_',names(CompIDxs) ,sep='' )
 #     save(PEAKS,file=fn)
 # }
  if (method=='MMD'){
    D <- list(Dists,mDists)
    names(D) <- c('Dists','mDists')
  } else {
    D <- list(Dists)
    names(D) <- c('Dists')
  }
  return(D)
}
