compPeakMatrix <-
function(Hists, fieldName='Counts'){

  nPeaks <- lapply(Hists, function(h){length(h[[fieldName]])})
  nPeaks <- as.integer(unique(nPeaks))
  if (length(nPeaks)!=1){
    stop('different peak sets per sample!')
  }


  nSamples <- length(Hists)
  Samples <- names(Hists)

  PeakHists <- vector("list", length(Hists[[1]][[fieldName]]))
  names(PeakHists) <-  names(Hists[[1]][[fieldName]])
  for (i in 1:nPeaks){
      Mids <- Hists[[1]]$Mids[i]
      Counts <- matrix(0, nrow=nSamples, ncol=length(Mids[[1]]))
      colnames(Counts) <- Mids[[1]]
      rownames(Counts) <- Samples
      for (j in 1:nSamples){
          Counts[j,] <- Hists[[j]][[fieldName]][[i]]
          if (!identical(Mids[[1]], Hists[[j]]$Mids[i][[1]])){
              stop('Mid points do not agree in different samples')
          }

      }
      PeakHists[[i]] <- Counts
  }

  return(PeakHists)

}
