compute.pvalues <-
function(B,W1,W2,Ns,dN,Sign=FALSE,smaller=FALSE){

  nPeaks <- nrow(B)

  Within <- cbind(W1,W2)
  # Within <- as.matrix(rowMeans(Within))
  AvsB <- as.matrix(B)
  # AvsB <- as.matrix(rowMeans(AvsB))
  AvsB <- cbind(AvsB,Within)
  ncomps <- ncol(AvsB)
  p <- matrix(0,nrow=nrow(AvsB),ncol=ncol(AvsB))
  colnames(p) <- colnames(AvsB)

  H0 <- as.vector(Within)
  if (ncol(Ns)>1){
    temp <- colnames(Within)
    sampleNames <- unlist(strsplit(temp,' vs '))
    H0.Ns <- rowMeans(Ns[,sampleNames])
    H0.Ns <-rep(H0.Ns,ncol(Within))
  } else {
    H0.Ns <-rep(Ns,ncol(Within))
  }
  
  
  if (max(dN)<max(Ns)){
    dN <- c(dN, max(Ns))
  }
  
  for (i in 1:length(dN)){
    
    if (i==1){
      if (ncol(Ns)==1){
        idx <- which(Ns<=dN[[i]])
      }
      H0.idx <- which(H0.Ns<=dN[[i]])
    } else {
      if (ncol(Ns)==1){
        idx <- which(Ns>dN[[i-1]]&Ns<=dN[[i]])
      }
      H0.idx <- which(H0.Ns>dN[[i-1]]&H0.Ns<=dN[[i]])
    }
   
    for (j in 1:ncomps){
      if (ncol(Ns)>1){
        comp <- colnames(AvsB)[j]
        sampleNames <- unlist(strsplit(comp,' vs '))
        CompNs <- rowMeans(Ns[,sampleNames])
        if (i==1){
          idx <- which(CompNs<=dN[[i]])
        } else {
          idx <- which(CompNs>dN[[i-1]]&CompNs<=dN[[i]])
        }
        if (length(idx)==0) next
      }
      
      if (Sign==FALSE)
        {
          if (smaller==FALSE)
            {
              p[idx,j] <- sapply(AvsB[idx,j],function(mmd){length(which(H0[H0.idx]>=mmd))/length(H0.idx)})
            }
          else
            {
              p[idx,j] <- sapply(AvsB[idx,j],function(mmd){length(which(H0[H0.idx]<=mmd))/length(H0.idx)})
            }
          
        }
      else
        {
          idxp <- idx[AvsB[idx,j]>=0]
          idxn <- idx[AvsB[idx,j]<0]
          if (smaller==FALSE)
            {
              p[idxp,j] <- sapply(AvsB[idxp,j],function(mmd){ length(which(H0[H0.idx]>=mmd))/length(H0.idx)})
              p[idxn,j] <- sapply(AvsB[idxn,j],function(mmd){ length(which(H0[H0.idx]<=mmd))/length(H0.idx)})
            }
          else
            {
              p[idxp,j] <- sapply(AvsB[idxp,j],function(mmd){  length(which(H0[H0.idx]<=mmd))/length(H0.idx)})
              p[idxn,j] <- sapply(AvsB[idxn,j],function(mmd){  length(which(H0[H0.idx]>=mmd))/length(H0.idx)})
            }
        }
    }
  }
  # Pall <- c(p,pctr)
  if (any(is.na(p))){
    message(length(which(is.na(p))),' NAs found  (of ', length(p),')')
    p[is.na(p)]=min(p[!is.na(p)])
  }
  Pc <- rowMax(p[,1:ncol(B)])
  
  fdr <- p.adjust(as.vector(p),method='BH')
  FDR <- matrix(0,nrow=nrow(p),ncol=ncol(p)+1)
  for (i in 1:ncol(p)){
    FDR[,i] <- fdr[(i-1)*nrow(p)+(1:nrow(p))]
  }
  if (any(is.na(FDR))){
    message(length(which(is.na(FDR))),' NAs found  (of ', length(FDR),')')
    FDR[is.na(FDR)]=min(FDR[!is.na(FDR)])
  }
  FDR[,i+1] <- rowMax(FDR[,1:ncol(B)])
  p <- cbind(p,Pc)
  colnames(p)[i+1] <- 'combined'
  colnames(FDR) <- colnames(p)
  
  #FDR <- FDR[1:nrow(p)]

  P <- list(p,FDR)
  names(P) <- c('pval','FDR')
  return(P)
}
