findOutliers <-
function(DBA, range=20, draw.on=TRUE){
  
  MD <- DBA$MD
  Counts <- MD$RawTotalCounts
  
  mybox <- boxplot(Counts,plot = FALSE,range=range)
  val <- rep(0,ncol(Counts))
  idx <- vector("list",ncol(Counts))
  for (i in 1:ncol(Counts)){
    if (any(mybox$group==i)){
      val[i] <- min(mybox$out[mybox$group==i])
      idx[[i]] <- which(Counts[,i]>val[i])
    }
  }
  idxOut <- unique(unlist(idx))
  idxIn <-setdiff(seq(1,nrow(Counts)),idxOut)
  if (draw.on) {
    mm <- max(log(Counts))
    tt <- hist(log(Counts[,1]),seq(0,mm,length.out=100),plot = FALSE)
    par(mfrow=c(ceiling(ncol(Counts)/2),2))
    for (i in 1:ncol(Counts)){
      hist(log(Counts[,i]),breaks=tt$breaks,main=colnames(Counts)[i],xlab='log Total Counts')
      lines(c(log(val[i]),log(val[i])),c(0,length(idx[[i]])),t='l',col='red',lwd=4)
      
    }
    
    dev.new()
    boxplot(Counts[idxIn,])
  }
  
  message(length(idxOut), ' peaks with very high counts found; -> should be excluded from further analysis')
  Filter <- list(idxOut,idxIn,val)
  names(Filter) <- c('HighPeakIds','FiltPeakIds','Threshold')
  
  DBA$MD$Filter <- Filter
  return(DBA)
}
