getPeakIds4shift <-
function(Reads,draw.on=TRUE,fname=NULL){

  Pos.p <- Reads$Pos.p
  Pos.n <- Reads$Pos.n

  Total.p <- mapply(Pos.p, FUN=length)
  Total.n <- mapply(Pos.n, FUN=length)

  summary(Total.p)
  summary(Total.n)

  x <- quantile(Total.p, probs=seq(0,1,0.1))
  ii1 <- which(Total.p>x[9] & Total.p<x[10])
  x <- quantile(Total.n, probs=seq(0,1,0.1))
  ii2 <- which(Total.n>x[9] & Total.n<x[10])
  Idx <- intersect(ii2, ii1)

  message('Using ',length(Idx), ' peaks to determine shift')
  if (draw.on){
    if (is.null(fname)){
      main = ''
    } else{
      main = fname
    }
    dev.new()
    # fn <- paste(pics.dir,'forwardVSReverse_',main,'pdf',sep='')
    # pdf(fn)
    smoothScatter(Total.p, Total.n, xlab='total counts on + strand', ylab='total counts on - strand', main=main)
    points(Total.p[Idx], Total.n[Idx], col='red')
    legend("topleft", pch=c(21),col='red', "peaks to determine strand shift")
    # dev.off()
}
  return(Idx)
}
