getReadsWrapper <-
function(chroms,Peaks,bam.file){
  
  Pos.p <- vector("list", 0)
  Pos.n <- Pos.p
  peak.id <- 0
  if (length(chroms)==0){
      return()
  }

  for (j in 1:length(chroms)){
    if (is.element(chroms[j],seqnames(seqinfo(Peaks)))){
      P <- Peaks[seqnames(Peaks)==chroms[j]]


      message('-chromosome: ', chroms[j], ' containing ', length(P), ' peaks')
      P <- cbind(rep(j,length(P)),start(P),end(P))
      reads <- getReads(P, chroms[j],bam.file)
      ids <- peak.id+seq(1, nrow(P))

      if (length(ids) != length(reads$Pos.p)){
        message('trouble on chromosome', chroms[j]) }
      Pos.p <- c(Pos.p,reads$Pos.p)
      Pos.n <- c(Pos.n,reads$Pos.n)
      names(Pos.p)[ids] <- names(reads$Pos.p)
      names(Pos.n)[ids] <- names(reads$Pos.n)
      peak.id <- ids[length(ids)]
    }

  }
  Reads <- list(Pos.p, Pos.n)
  names(Reads) <- c('Pos.p', 'Pos.n')
  return(Reads)
}
