getShift <-
function(Reads, Idx, bin.length=10, draw.on=TRUE,fname=NULL){

  Pos.p <- Reads$Pos.p[Idx]
  Pos.n <- Reads$Pos.n[Idx]

  message('using bin.length = ', bin.length, ' to determine shift.')
  R <- list(Pos.p, Pos.n)
  names(R) <- c('Pos.p', 'Pos.n')
  H <- compHists(R, bin.length=bin.length)

  shift <- rep(0, length(H$Counts.p))
  for (i in 1:length(H$Counts.p)){
    a <- ccf(H$Counts.n[[i]], H$Counts.p[[i]], lag.max=40, plot=FALSE);
    shift[i] <- a$lag[which.max(a$acf)]
  }

  shift <- shift*bin.length
  message('shifts statistics:')
  print(summary(shift))
  if (draw.on){
    if (is.null(fname)){
      main = ''
    } else{
      main = fname
    }
    dev.new()
    # fn <- paste(picss.dir,'/strandShifts_',main,'pdf',sep='')
    # pdf(fn)
    hist(shift, 100, xlab='shift between + and - strand [bp]', main=main)
    lines(x=c(median(shift), median(shift)), y=c(0,length(shift)), col='red', lwd=2)
    # dev.off()

}
  shift <- median(shift)
  message('determined shift between positive and reverse strand is: ', shift )
  return(shift)
}
