sortReads <-
function(r, Peaks){
  numPeaks <- length(Peaks)
  Pos.p <- vector("list", numPeaks)
  Pos.n <- Pos.p
  peak.id <- 0
  for (i in 1:length(r)){
    if (length(r[[i]])==0){
      next
    }
    
    reads <- r[[i]]
    if (length(reads$Pos.p)==0&length(reads$Pos.n)==0){
      next
    }
    ids <- peak.id+seq(1, length(reads$Pos.p))
    Pos.p[ids] <- reads$Pos.p
    Pos.n[ids] <- reads$Pos.n
    names(Pos.p)[ids] <- names(reads$Pos.p)
    names(Pos.n)[ids] <- names(reads$Pos.n)
    peak.id <- ids[length(ids)]
  }
  Reads <- list(Pos.p, Pos.n)
  names(Reads) <- c('Pos.p', 'Pos.n')
  if (length(Reads$Pos.p)!=length(Peaks)){
      stop('some peaks missing')
  }
  if (length(Reads$Pos.n)!=length(Peaks)){
      stop('some peaks missing')
  }
  #compare names with peak coordinates
  tmp <- lapply(names(Reads$Pos.p),function(n){n=unlist(strsplit(n,':'));pos=n[2]})
  st1 <- sapply(tmp,function(pos){n=unlist(strsplit(pos,'-'));pos=as.integer(n[1])})
  en1 <- sapply(tmp,function(pos){n=unlist(strsplit(pos,'-'));pos=as.integer(n[2])})

  st2 <- start(Peaks)
  en2 <- end(Peaks)
  if (st1 !=st2 || en1!=en2){
      stop("something wrong with peak sorting")
  }


  return(Reads)
}
