\name{plotHistDists}
\alias{plotHistDists}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
  plot MMD distances
}
\description{  
  the generated plots are similar to MA plots, except that the computed
  distances (MMD) are shown on the y-axes instead of log fold change.  }

\usage{
plotHistDists(DBA, method = "MMD", group1, group2, 
              field4X = "NormTotalCounts", bUsePval = FALSE,
              pnames = "combined", thresh = 0.05, 
              save2file = FALSE, fn.pics,  ftype = pdf,
              xlim = NULL, ylim = NULL)
}
%- maybe also 'usage' for other objects documented here.
\arguments{ 
  \item{DBA}{ DBA object, after running compHistDists. }
  
  \item{method}{specify method used to determine distances between
    histograms (could be MMD, GMD or Pearson).}
  \item{group1}{sample ids of control group }
  
  \item{group2}{sample ids of treatment group}
 
  \item{field4X}{
    name of list element in DBA$MD that is used for pooling of
    peaks. (e.g. NormTotalCounts or RawTotalCounts)
  }
  \item{bUsePval}{logical indicating whether to use FDR (FALSE) or p-value
          (TRUE) for thresholding.}

  \item{pnames}{name of comparison used to generated p-values, eg. name1
    vs name2}
  \item{thresh}{threshold to show significant peaks. (e.g. < 0.05)}
  
  \item{save2file}{
    if TRUE plot is saved to pdf file
  }
  \item{fn.pics}{file name, where the plot should be saved to.
  }
  \item{ftype}{file format for saving the plot (pdf, postcsript, png)}
  \item{xlim}{the x limits (x1, x2) of the plot. The default value,
    'NULL', indicates that the range of the finite values to be
    plotted should be used.}
  
  \item{ylim}{the y limits of the plot.}
}
%\details{
%%  ~~ If necessary, more details than the description above ~~
%}
%\value{
%}
%\references{
%% ~put references to the literature/web site here ~
% }
\author{
Gabriele Schweikert
}
%\note{
%%  ~~further notes~~
%}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  \link{getPeakProfiles},
  \link{getNormFactors},
  \link{compHistDists},
  \link{detPeakPvals}
}

\examples{

# load DBA objects with peak profiles and pairwise distances
data(Cfp1Dists)

# determine empirical p-values:
group1 <- c("WT.AB2", "Resc.AB2")
group2 <- c("Null.AB2")
Cfp1Pvals <- detPeakPvals(Cfp1Dists, group1=group1, group2=group2,
             name1='Wt/Resc', name2='Null')

# plot distances and peaks which are significantly different:

plotHistDists(Cfp1Pvals, group1=group1, group2=group2)

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
%\keyword{ ~kwd1 }
%\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
